Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -3184,159 +5087,314 @@
 					}
 
 				} else {
-					$this->message($headCode,'Test skipped',"
-					Use of GDLib has been disabled in the configuration.
-					Refer to section 'Basic Configuration' to change or review you configuration settings
-					",2);
+					$this->message($headCode, 'Test skipped', '
+						<p>
+							Use of GDLib has been disabled in the configuration.
+							<br />
+							Refer to section \'Basic Configuration\' to change
+							or review you configuration settings
+						</p>
+					', 2);
 				}
 			break;
 		}
 
-		if ($this->INSTALL['images_type'])	{
+		if ($this->INSTALL['images_type']) {
 			// End info
-			if ($this->fatalError)	{
-				$this->message('Info','Errors',"
-				It seems that you had some fatal errors in this test. Please make sure that your ImageMagick and GDLib settings are correct.
-				Refer to the 'Basic Configuration' section for more information and debugging of your settings.
-				");
+			if ($this->fatalError) {
+				$this->message('Info', 'Errors', '
+					<p>
+						It seems that you had some fatal errors in this test.
+						Please make sure that your ImageMagick and GDLib
+						settings are correct. Refer to the
+						\'Basic Configuration\' section for more information and
+						debugging of your settings.
+					</p>
+				');
 			}
 
 			$parseMS = t3lib_div::milliseconds() - $parseStart;
-			$this->message('Info','Parsetime',$parseMS.' ms');
+			$this->message('Info', 'Parsetime', '
+				<p>
+					' . $parseMS . ' ms
+				</p>
+			');
 		}
 		$this->output($this->outputWrapper($this->printAll()));
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if image file extension is enabled
+	 * Adds error message to the message array
 	 *
-	 * @param	[type]		$ext: ...
-	 * @param	[type]		$headCode: ...
-	 * @param	[type]		$short: ...
-	 * @return	[type]		...
+	 * @param string $ext The image file extension
+	 * @param string $headCode The header for the message
+	 * @param string $short The short description for the message
+	 * @return boolean TRUE if extension is enabled
 	 */
-	function isExtensionEnabled($ext, $headCode, $short)	{
-		if (!t3lib_div::inList($GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'],$ext))	{
-			$this->message($headCode,$short,'Skipped - extension not in the list of allowed extensions ([GFX][imagefile_ext]).',1);
+	function isExtensionEnabled($ext, $headCode, $short) {
+		if (!t3lib_div::inList($GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'],$ext)) {
+			$this->message($headCode, $short, '
+				<p>
+					Skipped - extension not in the list of allowed extensions
+					([GFX][imagefile_ext]).
+				</p>
+			',1);
 		} else {
 			return 1;
 		}
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generate the HTML after reading and converting images
+	 * Displays the verification and the converted image if succeeded
+	 * Adds error messages if needed
 	 *
-	 * @param	[type]		$imageFile: ...
-	 * @param	[type]		$IMcommands: ...
-	 * @param	[type]		$note: ...
-	 * @return	[type]		...
+	 * @param string $imageFile The file name of the converted image
+	 * @param array $IMcommands The ImageMagick commands used
+	 * @param string $note Additional note for image operation
+	 * @return array Contains content and highest error level
 	 */
-	function displayTwinImage ($imageFile, $IMcommands=array(), $note='')	{
-		$ex_rows='';
+	function displayTwinImage ($imageFile, $IMcommands=array(), $note='') {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'DisplayTwinImage.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+
+		$content = '';
+
 		$errorLevels=array(-1);
-		if ($imageFile)	{
+		if ($imageFile) {
+				// Get the subpart for the images
+			$imageSubpart = $this->contentObject->getSubpart($template, '###IMAGE###');
 			$verifyFile = t3lib_extMgm::extPath('install').'verify_imgs/'.basename($imageFile);
-#debug(array($imageFile,$this->backPath.'../'.substr($imageFile,strlen(PATH_site))),1);
 			$destImg = @getImageSize($imageFile);
 			$destImgCode ='<img src="'.$this->backPath.'../'.substr($imageFile,strlen(PATH_site)).'" '.$destImg[3].'>';
 			$verifyImg = @getImageSize($verifyFile);
 			$verifyImgCode = '<img src="'.$this->backPath.t3lib_extMgm::extRelPath('install').'verify_imgs/'.basename($verifyFile).'" '.$verifyImg[3].'>';
-			if (!$verifyImg)	{
-				$gifVersion=1;
-				$verifyFile_alt = substr($verifyFile,0,-3).'gif';
-				$verifyImg = @getImageSize($verifyFile_alt);
-				if ($verifyImg)	{
-// FIXME what is that? old code? t3lib/install/verify_imgs/ do not exist
-					$verifyImgCode = '<img src="'.$this->backPath.'t3lib/install/verify_imgs/'.basename($verifyFile_alt).'" '.$verifyImg[3].'>';
-					$verifyImgCode= '<table border="0" cellpadding="4" cellspacing="0" bgcolor="red"><tr><td align="center">'.$verifyImgCode.'<br />'.$this->fw('<strong>NO REFERENCE FOUND!</strong><br /><br />GIF version looks like this.').'</td></tr></table>';
-				} else {
-					$verifyImgCode= '<table border="0" cellpadding="4" cellspacing="0" bgcolor="red"><tr><td align="center">'.$this->fw('<strong>NO REFERENCE FOUND!</strong><br /><br />'.basename($verifyFile)).'</td></tr></table>';
-				}
-			}
 
 			clearstatcache();
 			$destImg['filesize'] = @filesize($imageFile);
 			clearstatcache();
 			$verifyImg['filesize'] = @filesize($verifyFile);
+				// Define the markers content
+			$imageMarkers = array(
+				'destWidth' => $destImg[0],
+				'destHeight' => $destImg[1],
+				'destUrl' => $this->backPath . '../' . substr($imageFile, strlen(PATH_site)),
+				'verifyWidth' => $verifyImg[0],
+				'verifyHeight' => $verifyImg[1],
+				'verifyUrl' => $this->backPath . t3lib_extMgm::extRelPath('install') . 'verify_imgs/' . basename($verifyFile),
+				'yourServer' => 'Your server:',
+				'yourServerInformation' => t3lib_div::formatSize($destImg['filesize']) . ', ' . $destImg[0] . 'x' . $destImg[1] . ' pixels',
+				'reference' => 'Reference:',
+				'referenceInformation' => t3lib_div::formatSize($verifyImg['filesize']) . ', ' . $verifyImg[0] . 'x' . $verifyImg[1] . ' pixels'
+			);
 
-			$ex_rows.='<tr>';
-			$ex_rows.='<td>'.$destImgCode.'</td>';
-			$ex_rows.='<td><img src="clear.gif" width="30" height="1"></td>';
-			$ex_rows.='<td>'.$verifyImgCode.'</td>';
-			$ex_rows.='</tr>';
+				// Display a warning if the generated image is more than 2KB larger than its reference...
+			if (($destImg['filesize']!=$verifyImg['filesize']) && (intval($destImg['filesize']) && ($destImg['filesize']-$verifyImg['filesize']) > 2048)) {
+					// Get the subpart for the different filesize message
+				$differentFileSizeSubpart = $this->contentObject->getSubpart($imageSubpart, '###DIFFERENTFILESIZE###');
+					// Define the markers content
+				$differentFileSizeMarkers = array(
+					'message' => 'File size is very different from reference',
+					'yourServerFileSize' => $destImg['filesize'],
+					'referenceFileSize' => $verifyImg['filesize']
+				);
+					// Fill the markers in the subpart
+				$differentFileSizeSubpart = $this->contentObject->substituteMarkerArray(
+					$differentFileSizeSubpart,
+					$differentFileSizeMarkers,
+					'###|###',
+					1,
+					1
+				);
 
-			$ex_rows.=$this->getTwinImageMessage('', 'Your server:', 'Reference:');
-			$ex_rows.=$this->getTwinImageMessage('', t3lib_div::formatSize($destImg['filesize']).', '.$destImg[0].'x'.$destImg[1].' pixels', t3lib_div::formatSize($verifyImg['filesize']).', '.$verifyImg[0].'x'.$verifyImg[1].' pixels');
-
-			if (($destImg['filesize']!=$verifyImg['filesize']) && (intval($destImg['filesize']) && ($destImg['filesize']-$verifyImg['filesize']) > 2048))	{	// Display a warning if the generated image is more than 2KB larger than its reference...
-				$ex_rows.=$this->getTwinImageMessage('File size is very different from reference', $destImg['filesize'], $verifyImg['filesize']);
 				$errorLevels[]=2;
 			}
-			if ($destImg[0]!=$verifyImg[0] || $destImg[1]!=$verifyImg[1])	{
-				$ex_rows.=$this->getTwinImageMessage('Pixel dimension are not equal!');
+				// Substitute the subpart for different filesize message
+			$imageSubpart = $this->contentObject->substituteSubpart(
+				$imageSubpart,
+				'###DIFFERENTFILESIZE###',
+				$differentFileSizeSubpart
+			);
+
+			if ($destImg[0]!=$verifyImg[0] || $destImg[1]!=$verifyImg[1]) {
+					// Get the subpart for the different pixel dimensions message
+				$differentPixelDimensionsSubpart = $this->contentObject->getSubpart($imageSubpart, '###DIFFERENTPIXELDIMENSIONS###');
+					// Define the markers content
+				$differentPixelDimensionsMarkers = array(
+					'message' => 'Pixel dimension are not equal!'
+				);
+					// Fill the markers in the subpart
+				$differentPixelDimensionsSubpart = $this->contentObject->substituteMarkerArray(
+					$differentPixelDimensionsSubpart,
+					$differentPixelDimensionsMarkers,
+					'###|###',
+					1,
+					1
+				);
+
 				$errorLevels[]=2;
 			}
-			if ($note)	{
-				$ex_rows.=$this->getTwinImageMessage($note[0],$note[1]);
+					// Substitute the subpart for different pixel dimensions message
+			$imageSubpart = $this->contentObject->substituteSubpart(
+				$imageSubpart,
+				'###DIFFERENTPIXELDIMENSIONS###',
+				$differentPixelDimensionsSubpart
+			);
+
+			if ($note) {
+					// Get the subpart for the note
+				$noteSubpart = $this->contentObject->getSubpart($imageSubpart, '###NOTE###');
+					// Define the markers content
+				$noteMarkers = array(
+					'message' => $note[0],
+					'label' => $note[1]
+				);
+					// Fill the markers in the subpart
+				$noteSubpart = $this->contentObject->substituteMarkerArray(
+					$noteSubpart,
+					$noteMarkers,
+					'###|###',
+					1,
+					1
+				);
 			}
-			if ($this->dumpImCommands && count($IMcommands))	{
-				$ex_rows.=$this->getTwinImageMessage('ImageMagick commands executed:',$this->formatImCmds($IMcommands));
+				// Substitute the subpart for the note
+			$imageSubpart = $this->contentObject->substituteSubpart(
+				$imageSubpart,
+				'###NOTE###',
+				$noteSubpart
+			);
+
+			if ($this->dumpImCommands && count($IMcommands)) {
+				$commands = $this->formatImCmds($IMcommands);
+					// Get the subpart for the ImageMagick commands
+				$imCommandsSubpart = $this->contentObject->getSubpart($imageSubpart, '###IMCOMMANDS###');
+					// Define the markers content
+				$imCommandsMarkers = array(
+					'message' => 'ImageMagick commands executed:',
+					'rows' => t3lib_div::intInRange(count($commands), 2, 10),
+					'commands' => htmlspecialchars(implode($commands, chr(10)))
+				);
+					// Fill the markers in the subpart
+				$imCommandsSubpart = $this->contentObject->substituteMarkerArray(
+					$imCommandsSubpart,
+					$imCommandsMarkers,
+					'###|###',
+					1,
+					1
+				);
 			}
+				// Substitute the subpart for the ImageMagick commands
+			$imageSubpart = $this->contentObject->substituteSubpart(
+				$imageSubpart,
+				'###IMCOMMANDS###',
+				$imCommandsSubpart
+			);
+				// Fill the markers
+			$imageSubpart = $this->contentObject->substituteMarkerArray(
+				$imageSubpart,
+				$imageMarkers,
+				'###|###',
+				1,
+				1
+			);
+
 		} else {
-			$ex_rows.=$this->getTwinImageMessage('There was no result from the ImageMagick operation', "Below there's a dump of the ImageMagick commands executed:<br />".$this->formatImCmds($IMcommands));
+				// Get the subpart when no image has been generated
+			$noImageSubpart = $this->contentObject->getSubpart($template, '###NOIMAGE###');
+			$commands = $this->formatImCmds($IMcommands);
+
+			if (count($commands)) {
+					// Get the subpart for the ImageMagick commands
+				$commandsSubpart = $this->contentObject->getSubpart($noImageSubpart, '###COMMANDSAVAILABLE###');
+					// Define the markers content
+				$commandsMarkers = array(
+					'rows' => t3lib_div::intInRange(count($commands), 2, 10),
+					'commands' => htmlspecialchars(implode($commands, chr(10)))
+				);
+					// Fill the markers in the subpart
+				$commandsSubpart = $this->contentObject->substituteMarkerArray(
+					$commandsSubpart,
+					$commandsMarkers,
+					'###|###',
+					1,
+					1
+				);
+			}
+				// Substitute the subpart for the ImageMagick commands
+			$noImageSubpart = $this->contentObject->substituteSubpart(
+				$noImageSubpart,
+				'###COMMANDSAVAILABLE###',
+				$commandsSubpart
+			);
+				// Define the markers content
+			$noImageMarkers = array(
+				'message' => 'There was no result from the ImageMagick operation',
+				'label' => 'Below there\'s a dump of the ImageMagick commands executed:'
+			);
+				// Fill the markers
+			$noImageSubpart = $this->contentObject->substituteMarkerArray(
+				$noImageSubpart,
+				$noImageMarkers,
+				'###|###',
+				1,
+				1
+			);
+
 			$errorLevels[]=3;
 		}
-		$out='<table border="0" cellpadding="0" cellspacing="0" align="center" width="300">'.$ex_rows.'</table>';
+			// Substitute the subpart when image has been generated
+		$content = $this->contentObject->substituteSubpart(
+			$template,
+			'###IMAGE###',
+			$imageSubpart
+		);
+			// Substitute the subpart when no image has been generated
+		$content = $this->contentObject->substituteSubpart(
+			$content,
+			'###NOIMAGE###',
+			$noImageSubpart
+		);
 
-		return array($out,max($errorLevels));
+		return array($content, max($errorLevels));
 	}
 
 	/**
-	 * [Describe function...]
+	 * Format ImageMagick commands for use in HTML
 	 *
-	 * @param	[type]		$message: ...
-	 * @param	[type]		$label_1: ...
-	 * @param	[type]		$label_2: ...
-	 * @return	[type]		...
+	 * @param array $arr The ImageMagick commands
+	 * @return string The formatted commands
 	 */
-	function getTwinImageMessage($message, $label_1="", $label_2='')	{
-		if ($message)	$out.='<tr><td colspan="3"><strong>'.$this->fw($message).'</strong></td></tr>';
-		if ($label_1 && !$label_2)	{
-			$out.='<tr><td colspan="3">'.$this->fw($label_1).'</td></tr>';
-		} elseif ($label_1 || $label_2)	{
-			$out.='<tr><td>'.$this->fw($label_1).'</td><td></td><td>'.$this->fw($label_2).'</td></tr>';
+	function formatImCmds($arr) {
+		$out = array();
+		if (is_array($arr)) {
+			foreach ($arr as $k => $v) {
+				$out[] = $v[1];
+				if ($v[2]) {
+					$out[]='   RETURNED: ' . $v[2];
+				}
+			}
 		}
+
 		return $out;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generate the menu for the test menu in 'image processing'
 	 *
-	 * @param	[type]		$arr: ...
-	 * @return	[type]		...
+	 * @return string The HTML for the test menu
 	 */
-	function formatImCmds($arr)	{
-		$out=array();
-		if (is_array($arr))	{
-			reset($arr);
-			while(list($k,$v)=each($arr))	{
-				$out[]=$v[1];
-				if ($v[2])	$out[]='   RETURNED: '.$v[2];
-			}
-		}
-		if (count($out))	{
-			$col = t3lib_div::intInRange(count($out),2,10);
-			$outputStr = '<textarea cols=40 rows='.$col.' wrap="off" class="fixed-font">'.htmlspecialchars(implode($out,chr(10))).'</textarea>';
-			return '<form action="">'.$outputStr.'</form>';
-		};
-	}
+	function imagemenu() {
+			// Get the template file
+		$template = @file_get_contents(PATH_site . $this->templateFilePath . 'ImageMenu.html');
+			// Get the subpart for the menu
+		$menuSubPart = $this->contentObject->getSubpart($template, '###MENU###');
+			// Get the subpart for the single item in the menu
+		$menuItemSubPart = $this->contentObject->getSubpart($menuSubPart, '###MENUITEM###');
 
-	/**
-	 * [Describe function...]
-	 *
-	 * @return	[type]		...
-	 */
-	function imagemenu()	{
 		$menuitems = array(
 			'read' => 'Reading image formats',
 			'write' => 'Writing GIF and PNG',
@@ -3344,18 +5402,32 @@
 			'combining' => 'Combining images',
 			'gdlib' => 'GD library functions'
 		);
-		reset($menuitems);
-		$c=0;
-		$out=array();
-		while(list($k,$v)=each($menuitems))	{
-			$bgcolor = ($this->INSTALL['images_type']==$k ? ' class="activeMenu"' : ' class="generalTableBackground"');
-			$c++;
-			$out[]='<tr><td'.$bgcolor.'><a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[images_type]='.$k.'#testmenu').'">'.$this->fw($c.': '.$v).'</a></td></tr>';
+		$c = 0;
+
+		foreach ($menuitems as $k => $v) {
+				// Define the markers content
+			$markers = array(
+				'backgroundColor' => $this->INSTALL['images_type'] == $k ? 'activeMenu' : 'generalTableBackground',
+				'url' => htmlspecialchars($this->action . '&TYPO3_INSTALL[images_type]=' . $k . '#imageMenu'),
+				'item' => $v
+			);
+				// Fill the markers in the subpart
+			$items[] = $this->contentObject->substituteMarkerArray(
+				$menuItemSubPart,
+				$markers,
+				'###|###',
+				1,
+				1
+			);
 		}
+			// Substitute the subpart for the single item in the menu
+		$menuSubPart = $this->contentObject->substituteSubpart(
+			$menuSubPart,
+			'###MENUITEM###',
+			implode(chr(10), $items)
+		);
 
-		$code = '<table border="0" cellpadding="0" cellspacing="1">'.implode($out,'').'</table>';
-		$code = '<table border="0" cellpadding="0" cellspacing="0" id="imageMenu"><tr><td>'.$code.'</td></tr></table>';
-		return '<div align="center">'.$code.'</div>';
+		return $menuSubPart;
 	}
 
 
@@ -3376,20 +5448,32 @@
 	 **********************/
 
 	/**
-	 * @return	[type]		...
+	 * The Database Analyzer
+	 *
+	 * @return void
 	 */
-	function checkTheDatabase()	{
-		if (!$this->config_array['mysqlConnect'])	{
-			$this->message('Database Analyser','Your database connection failed',"
-				Please go to the 'Basic Configuration' section and correct this problem first.
-			",2);
+	function checkTheDatabase() {
+		$this->javascript[] = '<script type="text/javascript" src="' .
+			t3lib_div::getIndpEnv('TYPO3_SITE_URL') .
+			TYPO3_mainDir .
+			'contrib/prototype/prototype.js"></script>';
+		if (!$this->config_array['mysqlConnect']) {
+			$this->message('Database Analyser', 'Your database connection failed', '
+				<p>
+					Please go to the \'Basic Configuration\' section and correct
+					this problem first.
+				</p>
+			', 2);
 			$this->output($this->outputWrapper($this->printAll()));
 			return;
 		}
-		if ($this->config_array['no_database'])	{
-			$this->message('Database Analyser','No database selected',"
-				Please go to the 'Basic Configuration' section and correct this problem first.
-			",2);
+		if ($this->config_array['no_database']) {
+			$this->message('Database Analyser', 'No database selected', '
+				<p>
+					Please go to the \'Basic Configuration\' section and correct
+					this problem first.
+				</p>
+			', 2);
 			$this->output($this->outputWrapper($this->printAll()));
 			return;
 		}
@@ -3399,32 +5483,48 @@
 
 
 			// Getting number of static_template records
-		if ($whichTables['static_template'])	{
+		if ($whichTables['static_template']) {
 			$static_template_count = $GLOBALS['TYPO3_DB']->exec_SELECTcountRows('uid', 'static_template');
 		}
 		$static_template_count=intval($static_template_count);
 
 		$headCode ='Database Analyser';
-		$this->message($headCode,'What is it?',"
-			In this section you can get an overview of your currently selected database compared to sql-files. You can also import sql-data directly into the database or upgrade tables from earlier versions of TYPO3.
-		",0);
+		$this->message($headCode, 'What is it?', '
+			<p>
+				In this section you can get an overview of your currently
+				selected database compared to sql-files. You can also import
+				sql-data directly into the database or upgrade tables from
+				earlier versions of TYPO3.
+			</p>
+		', 0);
 
-		$cInfo='
-			Username: <strong>'.TYPO3_db_username.'</strong>
-			Host: <strong>'.TYPO3_db_host.'</strong>
-		';
-		$this->message($headCode, 'Connected to SQL database successfully',"
-		".trim($cInfo)."
-		",-1,1);
-		$this->message($headCode, 'Database',"
-			<strong>".TYPO3_db.'</strong> is selected as database.
-			Has <strong>'.count($whichTables)."</strong> tables.
-		",-1,1);
+		$this->message($headCode, 'Connected to SQL database successfully', '
+			<dl id="databaseConnected">
+				<dt>
+					Username:
+				</dt>
+				<dd>
+					' . TYPO3_db_username . '
+				</dd>
+				<dt>
+					Host:
+				</dt>
+				<dd>
+					' . TYPO3_db_host . '
+				</dd>
+			</dl>
+		', -1, 1);
 
+		$this->message($headCode, 'Database', '
+			<p>
+				<strong>' . TYPO3_db . '</strong> is selected as database.
+				<br />
+				Has <strong>' . count($whichTables) . '</strong> tables.
+			</p>
+		', -1, 1);
 
+
 			// Menu
-		$this->messageFunc_nl2br = 0;
-
 		$sql_files = array_merge(
 			t3lib_div::getFilesInDir(PATH_typo3conf,'sql',1,1),
 			array()
@@ -3432,117 +5532,157 @@
 
 		$action_type = $this->INSTALL['database_type'];
 		$actionParts = explode('|',$action_type);
-		if (count($actionParts)<2)	{
+		if (count($actionParts)<2) {
 			$action_type='';
 		}
 
-		$out='';
-		$out.='<tr>
-				<td nowrap="nowrap"><strong>'.$this->fw('Update required tables').'</strong></td>
-				<td' . ($action_type == 'cmpFile|CURRENT_TABLES' ? ' class="notice"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cmpFile|CURRENT_TABLES#bottom') . '"><strong>COMPARE</strong></a>') . '</td>
-				<td>'.$this->fw('&nbsp;').'</td>
-				<td>'.$this->fw('&nbsp;').'</td>
-			</tr>';
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckTheDatabaseMenu.html');
+			// Get the template part from the file
+		$menu = $this->contentObject->getSubpart($templateFile, '###MENU###');
 
-		$out.='<tr>
-				<td nowrap="nowrap"><strong>'.$this->fw('Dump static data').'</strong></td>
-				<td>'.$this->fw('&nbsp;').'</td>
-				<td nowrap="nowrap"' . ($action_type == 'import|CURRENT_STATIC' ? ' class="notice"' : '').'>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=import|CURRENT_STATIC#bottom') . '"><strong>IMPORT</strong></a>') . '</td>
-				<td>'.$this->fw('&nbsp;').'</td>
-			</tr>';
+		$menuMarkers = array(
+			'action' => $this->action,
+			'updateRequiredTables' => 'Update required tables',
+			'compare' => 'COMPARE',
+			'noticeCmpFileCurrent' => ($action_type == 'cmpFile|CURRENT_TABLES' ? ' class="notice"' : ''),
+			'dumpStaticData' => 'Dump static data',
+			'import' => 'IMPORT',
+			'noticeImportCurrent' => ($action_type == 'import|CURRENT_STATIC' ? ' class="notice"' : ''),
+			'noticeCmpTca' => ($action_type == "cmpTCA|" ? ' class="notice"' : ''),
+			'compareWithTca' => 'Compare with $TCA',
+			'noticeAdminUser' => ($action_type == "adminUser|" ? ' class="notice"' : ''),
+			'createAdminUser' => 'Create "admin" user',
+			'noticeUc' => ($action_type == "UC|" ? ' class="notice"' : ''),
+			'resetUserPreferences' => 'Reset user preferences',
+			'noticeCache' => ($action_type == "cache|" ? ' class="notice"' : ''),
+			'clearTables' => 'Clear tables'
+		);
+			// Get the subpart for extra SQL
+		$extraSql = $this->contentObject->getSubpart($menu, '###EXTRASQL###');
 
-		$out.='<tr>
-				<td colspan="4">&nbsp;</td>
-			</tr>';
-
-
-		reset($sql_files);
 		$directJump='';
-		while(list($k,$file)=each($sql_files))	{
-			if ($this->mode=="123" && !count($whichTables) && strstr($file,'_testsite'))	{
+		$extraSqlFiles = array();
+		foreach ($sql_files as $k => $file) {
+			if ($this->mode=="123" && !count($whichTables) && strstr($file,'_testsite')) {
 				$directJump = $this->action.'&TYPO3_INSTALL[database_type]=import|'.rawurlencode($file);
 			}
 			$lf=t3lib_div::testInt($k);
 			$fShortName = substr($file,strlen(PATH_site));
 
 			$spec1 = $spec2 = '';
-
-			$out.='<tr>
-				<td nowrap="nowrap">'.$this->fw($fShortName.' ('.t3lib_div::formatSize(filesize($file)).')').'</td>
-				<td' . ($action_type == 'cmpFile|' . $file ? ' class="notice"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cmpFile|' . rawurlencode($file) . '#bottom') . '"><strong>COMPARE</strong></a>') . '</td>
-				<td nowrap="nowrap"' . ($action_type == 'import|' . $file ? ' class="notice"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=import|' . rawurlencode($file) . '#bottom') . '"><strong>IMPORT' . $spec1 . $spec2 . '</strong></a>') . '</td>
-				<td nowrap="nowrap"' . ($action_type == 'view|' . $file ? ' class="notice"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=view|' . rawurlencode($file) . '#bottom') . '"><strong>VIEW' . $spec1 . $spec2 . '</strong></a>') . '</td>
-			</tr>';
+				// Define the markers content
+			$extraSqlMarkers = array(
+				'fileShortName' => $fShortName,
+				'fileSize' => t3lib_div::formatSize(filesize($file)),
+				'noticeCmpFile' => ($action_type == 'cmpFile|' . $file ? ' class="notice"' : ''),
+				'file' => rawurlencode($file),
+				'noticeImport' => ($action_type == 'import|' . $file ? ' class="notice"' : ''),
+				'specs' => $spec1 . $spec2,
+				'noticeView' => ($action_type == 'view|' . $file ? ' class="notice"' : ''),
+				'view' => 'VIEW'
+			);
+				// Fill the markers in the subpart
+			$extraSqlFiles[] = $this->contentObject->substituteMarkerArray(
+				$extraSql,
+				$extraSqlMarkers,
+				'###|###',
+				1,
+				0
+			);
 		}
-			// TCA
-		$out.='<tr>
-			<td></td>
-			<td colspan="3"' . ($action_type == "cmpTCA|" ? ' class="notice"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cmpTCA|#bottom') . '">Compare with $TCA</a>') . '</strong></td>
-		</tr>';
-		$out.='<tr>
-			<td></td>
-			<td colspan="3"' . ($action_type == "adminUser|" ? ' class="notice"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=adminUser|#bottom') . '">Create "admin" user</a>') . '</strong></td>
-		</tr>';
-		$out.='<tr>
-			<td></td>
-			<td colspan="3"' . ($action_type == "UC|" ? ' class="notice"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=UC|#bottom') . '">Reset user preferences</a>') . '</strong></td>
-		</tr>';
-		$out.='<tr>
-			<td></td>
-			<td colspan="3"' . ($action_type == "cache|" ? ' class="notice"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cache|#bottom') . '">Clear tables</a>') . '</strong></td>
-		</tr>';
+			// Substitute the subpart for extra SQL
+		$menu = $this->contentObject->substituteSubpart(
+			$menu,
+			'###EXTRASQL###',
+			implode(chr(10), $extraSqlFiles)
+		);
+			// Fill the markers
+		$menu = $this->contentObject->substituteMarkerArray(
+			$menu,
+			$menuMarkers,
+			'###|###',
+			1,
+			1
+		);
 
-		$theForm='<table border="0" cellpadding="2" cellspacing="2">'.$out.'</table>';
-		$theForm.='<a name="bottom"></a>';
-
-		if ($directJump)	{
-			if (!$action_type)	{
-				$this->message($headCode, 'Menu','
-				<script language="javascript" type="text/javascript">
-				window.location.href = "'.$directJump.'";
-				</script>',0,1);
+		if ($directJump) {
+			if (!$action_type) {
+				$this->message($headCode, 'Menu', '
+					<script language="javascript" type="text/javascript">
+						window.location.href = "' . $directJump . '";
+					</script>',
+				0, 1);
 			}
 		} else {
-			$this->message($headCode, 'Menu',"
-			From this menu you can select which of the available SQL files you want to either compare or import/merge with the existing database.<br /><br />
-			<strong>COMPARE:</strong> Compares the tables and fields of the current database and the selected file. It also offers to 'update' the difference found.<br />
-			<strong>IMPORT:</strong> Imports the SQL-dump file into the current database. You can either dump the raw file or choose which tables to import. In any case, you'll see a new screen where you must confirm the operation.<br />
-			<strong>VIEW:</strong> Shows the content of the SQL-file, limiting characters on a single line to a reader-friendly amount.<br /><br />
-			The SQL-files are selected from typo3conf/ (here you can put your own) and t3lib/stddb/ (TYPO3 distribution). The SQL-files should be made by the <em>mysqldump</em> tool or at least be formatted like that tool would do.
-	<br />
-			<br />
-			".$theForm."
-			",0,1);
+			$this->message($headCode, 'Menu', '
+				<p>
+					From this menu you can select which of the available SQL
+					files you want to either compare or import/merge with the
+					existing database.
+				</p>
+				<dl id="checkTheDatabaseExplanation">
+					<dt>
+						COMPARE:
+					</dt>
+					<dd>
+						Compares the tables and fields of the current database
+						and the selected file. It also offers to \'update\' the
+						difference found.
+					</dd>
+					<dt>
+						IMPORT:
+					</dt>
+					<dd>
+						Imports the SQL-dump file into the current database. You
+						can either dump the raw file or choose which tables to
+						import. In any case, you\'ll see a new screen where you
+						must confirm the operation.
+					</dd>
+					<dt>
+						VIEW:
+					</dt>
+					<dd>
+						Shows the content of the SQL-file, limiting characters
+						on a single line to a reader-friendly amount.
+					</dd>
+				</dl>
+				<p>
+					The SQL-files are selected from typo3conf/ (here you can put
+					your own) and t3lib/stddb/ (TYPO3 distribution). The
+					SQL-files should be made by the <em>mysqldump</em> tool or
+					at least be formatted like that tool would do.
+				</p>
+			' . $menu, 0, 1);
 		}
 
-
-		if ($action_type)	{
-			switch($actionParts[0])	{
+		if ($action_type) {
+			switch($actionParts[0]) {
 				case 'cmpFile':
 					$tblFileContent='';
 					if (!strcmp($actionParts[1],'CURRENT_TABLES')) {
 						$tblFileContent = t3lib_div::getUrl(PATH_t3lib.'stddb/tables.sql');
 
 						foreach ($GLOBALS['TYPO3_LOADED_EXT'] as $loadedExtConf) {
-							if (is_array($loadedExtConf) && $loadedExtConf['ext_tables.sql'])	{
+							if (is_array($loadedExtConf) && $loadedExtConf['ext_tables.sql']) {
 								$tblFileContent.= chr(10).chr(10).chr(10).chr(10).t3lib_div::getUrl($loadedExtConf['ext_tables.sql']);
 							}
 						}
-					} elseif (@is_file($actionParts[1]))	{
+					} elseif (@is_file($actionParts[1])) {
 						$tblFileContent = t3lib_div::getUrl($actionParts[1]);
 					}
-					if ($tblFileContent)	{
+					if ($tblFileContent) {
 						$fileContent = implode(
 							chr(10),
 							$this->getStatementArray($tblFileContent,1,'^CREATE TABLE ')
 						);
 						$FDfile = $this->getFieldDefinitions_fileContent($fileContent);
-						if (!count($FDfile))	{
+						if (!count($FDfile)) {
 							die ("Error: There were no 'CREATE TABLE' definitions in the provided file");
 						}
 
 							// Updating database...
-						if (is_array($this->INSTALL['database_update']))	{
+						if (is_array($this->INSTALL['database_update'])) {
 							$FDdb = $this->getFieldDefinitions_database();
 							$diff = $this->getDatabaseExtra($FDfile, $FDdb);
 							$update_statements = $this->getUpdateSuggestions($diff);
